# Community

Find inspiration in the community forums, ask for help, help others, share your work, report issues, add feature requests, and contribute improvements.

## Detailed discussions on Discourse

:::{note}
[Discourse](https://discourse.holoviz.org/) is the place for detailed discussions around code. Here we can ask for help, find answers to other users' questions, and showcase our work.

When asking questions, please include a [Minimal, Reproducible Example](https://stackoverflow.com/help/minimal-reproducible-example) if at all possible. It will make it much, much easier to help you.
:::

Go to the [HoloViz Discourse](https://discourse.holoviz.org/) and sign up.

Click [this link](https://discourse.holoviz.org/t/welcome-please-introduce-yourself/3310/) to *introduce yourself* to the community.

[![HoloViz Discourse](_static/images/join_community_discourse.png)](https://discourse.holoviz.org/)

## Quick chats on Discord

:::{note}
[Discord](https://discord.gg/rb6gPXbdAr) is the place for quick and live discussions.
:::

Click [this link](https://discord.gg/rb6gPXbdAr) to sign up.

Then *introduce yourself* in the `introduce-yourself` channel.

[![HoloViz Discourse](_static/images/join_community_discord.png)](https://discord.gg/rb6gPXbdAr)

## Bugs, Features, and Contributions on Github

:::{note}
We can report bugs, ask for new features, and contribute improvements at [github.com/holoviz/panel](https://github.com/holoviz/panel).

Before reporting bugs or asking for new features, please make sure they are not already in the [*Issues tracker*](https://github.com/holoviz/panel/issues).
:::

[![Github Issues](_static/images/join_community_github.png)](https://github.com/holoviz/panel/issues).

Create an account by following [this guide](https://docs.github.com/en/get-started/quickstart/creating-an-account-on-github).

## Announcements and Showcases on Social Media

Follow Panel on [X](https://x.com/Panel_org).

[![Panel on X](_static/images/join_community_twitter.png)](https://x.com/Panel_org)

Follow Panel on [LinkedIn](https://www.linkedin.com/company/panel-org)

[![Panel on LinkedIn](_static/images/join_community_linkedin.png)](https://www.linkedin.com/company/panel-org)

## Community Resources at Awesome Panel

Bookmark [Awesome Panel](https://awesome-panel.org).

[![Awesome Panel](_static/images/awesome-panel.png)](https://awesome-panel.org)

## Contribute

Panel is an open source, community-driven project. We are nothing without the community.

If you want to start contributing, check out the [Contributing Guide](https://github.com/holoviz/panel/blob/main/CONTRIBUTING.MD). Thanks.

[![Panel is an Open Source, Community-driven project](_static/images/join_community_open_source.png)](https://github.com/holoviz/panel/blob/main/CONTRIBUTING.MD)

## Resources

- [Awesome Panel](https://awesome-panel.org).
- [Contributing Guide](https://github.com/holoviz/panel/blob/main/CONTRIBUTING.MD)
- [Discord](https://discord.gg/rb6gPXbdAr)
- [Discourse](https://discourse.holoviz.org/)
- [Github](https://github.com/holoviz/panel)
- [LinkedIn](https://www.linkedin.com/company/panel-org)
- [X](https://x.com/Panel_org)
